/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2018 Toma
 *
 *	[ ROM ]
 */

#ifndef _kanji_h_
#define _kanji_h_

/*
 *	^`
 */
enum {
	KANJI_ROM_NONE = 0,					/* ROMȂ */
	KANJI_ROM_JIS78L1,					/* JIS78 LEVEL 1 for FM-7/77 */
	KANJI_ROM_JIS78L1E,					/* JIS78 LEVEL 1 (Emulation) */
	KANJI_ROM_JIS78L1A,					/* JIS78 LEVEL 1 for FM77AV */
	KANJI_ROM_JIS83L1,					/* JIS83 LEVEL 1 */
	KANJI_ROM_JIS83L2,					/* JIS83 LEVEL 2 */
	KANJI_ROM_JIS78L1N,					/* JIS78 LEVEL 1 for FM77AV40EX/SX,
										   {ʐMJ[h */
	KANJI_ROM_UNKNOWN,					/* s\ */
	KANJI_ROM_TMP,						/* ROM */
};

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL kanji_init(void);
										/*  */
void FASTCALL kanji_cleanup(void);
										/* N[Abv */
void FASTCALL kanji_reset(void);
										/* Zbg */
BOOL FASTCALL kanji_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL kanji_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL kanji_save(int fileh);
										/* Z[u */
BOOL FASTCALL kanji_load(int fileh, int ver);
										/* [h */
#if XM7_VER >= 2
int FASTCALL kanji_make_temporary(BYTE *kanji_tmp, BYTE subtype);
#else
int FASTCALL kanji_make_temporary(BYTE *kanji_tmp);
#endif
										/* ROM쐬 */

/*
 *	v[N
 */
extern WORD kanji_addr;
										/* AhXWX^() */
extern BYTE *kanji_rom;
										/* PROM(JIS78) */
extern int kanji_rom_type;
										/* PROM(JIS78) */
#if XM7_VER >= 2
extern BYTE *kanji_rom1;
										/* PROM(JIS83) */
extern int kanji_rom1_type;
										/* PROM(JIS83) */
#endif
#if XM7_VER >= 2
extern BYTE *kanji_rom2;
										/* QROM */
extern int kanji_rom2_type;
										/* QROM */
#endif
#if XM7_VER >= 3 || defined(JSUB)
extern BYTE *kanji_romn;
				/* PROM for {ʐMJ[h/FM77AV40EXROM */
extern int kanji_romn_type;
				/* PROM for {ʐMJ[h/FM77AV40EXROM */
#endif
#if XM7_VER == 1
extern BOOL kanji_enable;
										/* ROMLtO for for FM-7/8 */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _kanji_h_ */
