/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2018 Toma
 *
 *	[ CCPUeI/O ]
 */

#ifndef _mainetc_h_
#define _mainetc_h_

/*
 *	萔`
 */
#define	BANKSEL_DISABLE			0
#define	BANKSEL_ENABLE			1
#define	BANKSEL_ENABLE_DIPSW	2
#define	BANKSEL_RAMFILE			3

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL mainetc_init(void);
										/*  */
void FASTCALL mainetc_cleanup(void);
										/* N[Abv */
void FASTCALL mainetc_reset(void);
										/* Zbg */
BOOL FASTCALL mainetc_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL mainetc_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL mainetc_save(int fileh);
										/* Z[u */
BOOL FASTCALL mainetc_load(int fileh, int ver);
										/* [h */
void FASTCALL mainetc_fdc(void);
										/* FDC荞 */
#if XM7_VER == 1 && defined(SFDC)
void FASTCALL mainetc_sfdc(void);
										/* SFDC荞 */
#endif	/* XM7_VER == 1 && defined(SFDC) */
void FASTCALL mainetc_lp(void);
										/* Cv^荞 */
BOOL FASTCALL mainetc_beep(void);
										/* BEEPCxg */

/*
 *	v[N
 */
extern BOOL key_irq_flag;
										/* L[{[h荞 v */
extern BOOL key_irq_mask;
										/* L[{[h荞 }XN */
extern BOOL lp_irq_flag;
										/* v^荞 v */
extern BOOL lp_irq_mask;
										/* v^荞 }XN */
extern BOOL timer_irq_flag;
										/* ^C}[荞 v */
extern BOOL timer_irq_mask;
										/* ^C}[荞 }XN */
extern BOOL mfd_irq_flag;
										/* FDC荞 tO */
extern BOOL mfd_irq_mask;
										/* FDC荞 }XN */
extern BOOL txrdy_irq_flag;
										/* TxRDY荞 tO */
extern BOOL txrdy_irq_mask;
										/* TxRDY荞 }XN */
extern BOOL rxrdy_irq_flag;
										/* RxRDY荞 tO */
extern BOOL rxrdy_irq_mask;
										/* RxRDY荞 }XN */
extern BOOL syndet_irq_flag;
										/* SYNDET荞 tO */
extern BOOL syndet_irq_mask;
										/* SYNDET荞 }XN */
#ifdef MOUSE
extern BOOL ptm_irq_flag;
										/* PTM荞 tO */
extern BOOL ptm_irq_mask;
										/* PTM荞 }XN */
#endif
extern BOOL opn_irq_flag;
										/* OPN荞 tO */
extern BOOL whg_irq_flag;
										/* WHG荞 tO */
extern BOOL thg_irq_flag;
										/* THG荞 tO */
#if XM7_VER >= 2 || (XM7_VER == 1 && defined(SFDC))
extern BOOL dma_irq_flag;
										/* DMA荞 tO */
#endif
extern BOOL beep_flag;
										/* BEEPLtO */
extern BOOL speaker_flag;
										/* Xs[JLtO */
#if XM7_VER == 1
extern BYTE banksel_en;
										/* oN؂芷Cl[u[h */
extern BOOL keyport_en;;
										/* CKeyI/OportCl[utO */
extern BOOL fm7irq_en;;
										/* FM-8FM-7 IRQCl[utO */
#ifdef SFDC
extern BOOL sfd_drq_flag;
										/* SFD DRQpXtO */
extern BOOL sfd_firq_mode;
										/* SFD FIRQ荞݃[h؂芷tO */
extern BOOL sfd_irq_flag;
										/* SFDC荞 tO */
extern BOOL sfd_irq_mask;
										/* SFDC荞 }XN */
extern BOOL sfdc_irq;
										/* SFDC荞ݏLEtO */
#endif	/* XM7_VER == 1 && defined(SFDC) */
extern BOOL mfdc_irq;
										/* MFDC荞ݏLEtO */
#endif	/* XM7_VER == 1 */
#ifdef __cplusplus
}
#endif

#endif	/* _mainetc_h_ */
