/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2018 Toma
 *
 *	[ }`y[W ]
 */

#include <string.h>
#include "xm7.h"
#include "multipag.h"
#include "display.h"
#include "ttlpalet.h"
#include "subctrl.h"
#include "apalet.h"
#include "device.h"

/*
 *	O[o [N
 */
BYTE multi_page;						/* }`y[W [N */

/*
 *	ID
 */
#define	ID	MAKEID('M', 'P', 'A', 'G')
//#define MULTIPAGE_LOG

/*
 *	}`y[W
 *	
 */
BOOL FASTCALL multipag_init(void)
{
	return TRUE;
}

/*
 *	}`y[W
 *	N[Abv
 */
void FASTCALL multipag_cleanup(void)
{
}

/*
 *	}`y[W
 *	Zbg
 */
void FASTCALL multipag_reset(void)
{
	LOG0(Normal, "Zbg");

	multi_page = 0;
}

/*
 *	}`y[W
 *	PoCgǂݏo
 */
BOOL FASTCALL multipag_readb(WORD addr, BYTE *dat)
{
#if XM7_VER == 1
	/* FM-8[hł͖ */
	if (fm_model == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (addr != 0xfd37) {
		return FALSE;
	}

	/* FFǂݏo */
	*dat = 0xff;
	return TRUE;
}

/*
 *	}`y[W
 *	PoCg
 */
BOOL FASTCALL multipag_writeb(WORD addr, BYTE dat)
{
#if XM7_VER == 1
	/* FM-8[hł͖ */
	if (fm_model == MODEL_FM8) {
		return FALSE;
	}
#endif

	if (addr != 0xfd37) {
		return FALSE;
	}

	if ((BYTE)(multi_page & 0x70) == (BYTE)(dat & 0x70)) {
		/* \ԂɕύXȂꍇ̓f[^LċA */
		multi_page = dat;
		multipage_notify();
		return TRUE;
	}

	/* f[^L */
	multi_page = dat;
	multipage_notify();

	/* pbgĐݒ */
	if (crt_flag) {
#if XM7_VER >= 2
#if XM7_VER >= 3
		if (!(screen_mode & SCR_ANALOG)) {
#else
		if (!mode320) {
#endif
			ttlpalet_notify();
		}
		else {
			apalet_notify();
		}
#else
		ttlpalet_notify();
#endif
	}

	return TRUE;
}

/*
 *	}`y[W
 *	Z[u
 */
BOOL FASTCALL multipag_save(int fileh)
{
	LOG0(Normal, "Z[u");

	return file_byte_write(fileh, multi_page);
}

/*
 *	}`y[W
 *	[h
 */
BOOL FASTCALL multipag_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	LOG0(Normal, "[h");

	return file_byte_read(fileh, &multi_page);
}
