/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2018 Toma
 *
 *	[ Win32API TEh ]
 */

#ifdef _WIN32

#ifndef _w32_snd_h_
#define _w32_snd_h_

/*
 *	萔`
 */
#define SNDBUF					20	/* WAVő哯 */
#define FMQUEUE_SIZE			1024	/* WX^݃L[TCY */
#define CHSEPARATION_DEFAULT	7	/* `lZp[VftHgl */
#define FMVOLUME_DEFAULT		0	/* FM{[ftHgl */
#define PSGVOLUME_DEFAULT		-2	/* PSG{[ftHgl */
#define BEEPVOLUME_DEFAULT		-24	/* BEEP{[ftHgl */
#define CMTVOLUME_DEFAULT		-24	/* CMTj^{[ftHgl */
#define WAVEVOLUME_DEFAULT		-6	/* eʉ{[ftHgl */
#define SCCICHIP_UNKNOWN		0	/* SCCI `bvs */
#define SCCICHIP_OPN			1	/* SCCI `bv:OPN    (YM2203) */
#define SCCICHIP_OPNA			2	/* SCCI `bv:OPNA   (YM2608) */
#define SCCICHIP_OPNBB			3	/* SCCI `bv:OPNBB  (YM2610B) */
#define SCCICHIP_PSG			4	/* SCCI `bv:PSG/SSG(AY-3-8910/YM2149) */

enum {
	PAN_FL = 0,
	PAN_L,
	PAN_C,
	PAN_R,
	PAN_FR,
};

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL InitSnd(void);
										/*  */
void FASTCALL CleanSnd(void);
										/* N[Abv */
#ifdef SOUNDENGINE
void FASTCALL InitSCCI(void);
										/* SCCI */
void FASTCALL CleanSCCI(void);
										/* SCCIN[Abv */
void FASTCALL LoadSCCI(void);
										/* SCCI[h */
#endif
BOOL FASTCALL SelectSnd(HWND hWnd);
										/* ZNg */
void FASTCALL ApplySnd(void);
										/* Kp */
void FASTCALL PlaySnd(void);
										/* tJn */
void FASTCALL StopSnd(void);
										/* t~ */
BOOL FASTCALL ProcessSnd(BOOL bZero);
										/* obt@[U莞 */
void FASTCALL WaitSnd(void);
										/* TEho͊ҋ@ */
int FASTCALL GetLevelSnd(int ch);
										/* TEhx擾 */
void FASTCALL OpenCaptureSnd(char *fname);
										/* WAVLv`Jn */
void FASTCALL CloseCaptureSnd(void);
										/* WAVLv`I */
BOOL FASTCALL GetMute(int ch);
										/* ~[gԎ擾 */
void FASTCALL SetMute(int ch, BOOL mute);
										/* ~[gԐݒ */
#ifdef SOUNDENGINE
void FASTCALL ROMEO_Mute(BOOL flag);
										/* ROMEO~[g */
void FASTCALL SCCI_Mute(BOOL flag);
										/* SCCI~[g */
#endif
#ifdef FDDSND
void FASTCALL InitFDDSnd(void);
										/*  */
void FASTCALL CleanFDDSnd(void);
										/* N[Abv */
#endif
void FASTCALL SetSoundVolume(void);
										/* {[ݒ */
void FASTCALL SetSoundVolume2(UINT uSp, int nFM, int nPSG,
							  int nBeep, int nCMT, int nWav);
										/* {[ݒ2 */

/*
 *	v[N
 */
extern UINT nSampleRate;
										/* Tv[g(HzA0Ŗ) */
extern UINT nSoundBuffer;
										/* TEhobt@(_uAms) */
extern BOOL bInterpolation;
										/* TEhԃ[h */
extern BOOL bPreciseMix;
										/* x[h */
extern UINT nBeepFreq;
										/* BEEPg(Hz) */
extern int hWavCapture;
										/* WAVLv`t@Cnh */
extern BOOL bWavCapture;
										/* WAVLv`Jn */
extern UINT uStereoOut;
										/* o̓[h */
extern BOOL bForceStereo;
										/* XeIo */
extern BOOL bTapeMon;
										/* e[vj^ */
#ifdef SOUNDENGINE
extern BOOL bUseRomeo;
										/* ݂gptO */
extern BOOL bUseSCCI;
										/* SCCIgptO */
extern BYTE nSCCI_ChipInfo[4];
										/* SCCI TEh`bv */
#endif
#ifdef FDDSND
extern UINT uSeekVolume;
										/* V[N */
#endif
extern UINT uChSeparation;
										/* XeI`lZp[V */
extern int nFMVolume;
										/* FM{[ */
extern int nPSGVolume;
										/* PSG{[ */
extern int nBeepVolume;
										/* BEEP{[ */
extern int nCMTVolume;
										/* CMTj^{[ */
#ifdef FDDSND
extern int nWaveVolume;
										/* ʉ{[ */
#endif
#if XM7_VER == 1
extern BOOL bFMXPSG;
										/* FM-X PSGG~[V[h() */
#endif
extern BOOL bStickyFocusFlag;
										/* XeBbL[tH[JXtO */
extern int pan_set[5][4];
										/* p` */
extern const int pan_set_def[5][4];
										/* p`ftHg */
#ifdef __cplusplus
}
#endif

#endif	/* _w32_snd_h_ */
#endif	/* _WIN32 */
